<template>
  <div v-if="loading">
    <Loader />
  </div>
  <div v-if="!loading" class="card shadow-sm">
    <form id="formItems" class="needs-validation" novalidate>
      <div class="card-header">
        <h3 class="card-title" style="font-size: 20px; font-weight: bold">
          แก้ไขสินค้า
        </h3>
      </div>
      <!-- form -->
      <div class="card-body">
        <!-- -->
        <div class="row mb-5">
          <div class="col-sm-1" />
          <div class="col-sm-11">
            <h3>
              <i class="bi bi-file-earmark-text" style="font-size: 20px"></i>
              รายละเอียดสินค้า
            </h3>
          </div>
        </div>
        <div class="row d-flex justify-content-center">
          <div class="col-sm-5">
            <label for="selectMainProduct" class="required form-label col-sm-10"
              >กลุ่มสินค้าหลัก</label
            >
            <select
              class="form-select mb-4"
              v-model="form.selectMainProduct"
              id="validationTooltip01"
              required
            >
              <option v-for="item in mainProduct" :key="item" :value="item.id">
                {{ item.main_product_group_code }} |
                {{ item.main_product_group_name }}
              </option>
            </select>
            <div class="invalid-feedback text-end">กรุณาเลือก</div>
          </div>
          <div class="col-sm-5">
            <label
              for="selectSecondaryProduct"
              class="required form-label col-sm-10"
              >กลุ่มสินค้ารอง</label
            >
            <select
              class="form-select mb-4"
              v-model="form.selectSubProduct"
              id="validationTooltip01"
              required
            >
              <option v-for="item in subProduct" :key="item" :value="item.id">
                {{ item.sub_product_group_code }} |
                {{ item.sub_product_group_name }}
              </option>
            </select>
            <div class="invalid-feedback text-end">กรุณาเลือก</div>
          </div>
        </div>
        <div class="row d-flex justify-content-center">
          <label for="ProductName" class="required form-label col-sm-10"
            >ชื่อสินค้า</label
          >
          <div class="col-sm-10">
            <input
              v-model="form.product_name"
              type="text"
              class="form-control mb-4"
              id="ProductName"
              name="ProductName"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>

        <div class="row d-flex justify-content-center">
          <label for="detail" class="form-label col-sm-10">รายละเอียด</label>
          <div class="col-sm-10">
            <input
              v-model="form.product_desc"
              type="text"
              class="form-control mb-4"
              id="detail"
              name="detail"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
        </div>

        <div class="row d-flex justify-content-center">
          <div class="col-sm-5">
            <label for="barcode" class="form-label required col-sm-10"
              >Barcode</label
            >
            <input
              v-model="form.product_barcode"
              type="text"
              class="form-control mb-4"
              id="barcode"
              name="barcode"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
          <div class="col-sm-5">
            <label for="pog" class="form-label col-sm-10">POG</label>
            <input
              v-model="form.product_pog"
              type="text"
              class="form-control"
              id="pog"
              name="pog"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
        </div>

        <hr class="mt-10 mb-8" style="color: LightGrey" />

        <div class="row mb-5">
          <div class="col-sm-1" />
          <div class="col-sm-11">
            <h3>
              <i class="bi bi-cash-coin" style="font-size: 20px"></i> ราคาสินค้า
            </h3>
          </div>
        </div>

        <div class="row d-flex justify-content-center">
          <div class="col-sm-5">
            <label for="retailPrice" class="required form-label col-sm-10"
              >ราคาทุน</label
            >
            <input
              v-model="form.product_cost_price"
              type="number"
              min="0"
              class="form-control mb-4"
              id="retailPrice"
              name="retailPrice"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
          <div class="col-sm-5">
            <label for="retailPrice" class="required form-label col-sm-10"
              >ราคาขายส่ง</label
            >
            <input
              v-model="form.product_wholesale_price"
              type="number"
              min="0"
              class="form-control mb-4"
              id="retailPrice"
              name="retailPrice"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>

        <div class="row d-flex justify-content-center">
          <div class="col-sm-5">
            <label for="retailPrice" class="required form-label col-sm-10"
              >ราคาขายปลีก</label
            >
            <input
              v-model="form.product_retail_price"
              type="number"
              min="0"
              class="form-control mb-4"
              id="retailPrice"
              name="retailPrice"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
          <div class="col-sm-5">
            <label for="retailPrice" class="form-label col-sm-10"
              >ราคาโปรโมชั่น</label
            >
            <input
              v-model="form.product_promotion_price"
              type="number"
              min="0"
              class="form-control"
              id="retailPrice"
              name="retailPrice"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
        </div>

        <hr class="mt-10 mb-8" style="color: LightGrey" />

        <div class="row mb-5">
          <div class="col-sm-1" />
          <div class="col-sm-11">
            <h3>
              <i class="bi bi-box-seam" style="font-size: 20px"></i> คลังสินค้า
            </h3>
          </div>
        </div>

        <div class="row d-flex justify-content-center">
          <div class="col-sm-5">
            <label for="min" class="form-label col-sm-10">Min</label>
            <input
              v-model="form.product_min_stock"
              type="number"
              class="form-control mb-4"
              id="min"
              name="min"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
          <div class="col-sm-5">
            <label for="max" class="form-label col-sm-10">Max</label>
            <input
              v-model="form.product_max_stock"
              type="number"
              class="form-control mb-4"
              id="Max"
              name="Max"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
        </div>

        <div class="row d-flex justify-content-start">
          <div class="col-sm-1" />
          <div class="col-sm-5">
            <label for="min" class="form-label col-sm-10">ยอดยกมา Qty</label>
            <input
              v-model="form.product_bring_qty"
              disabled
              type="number"
              class="form-control"
              id="min"
              name="min"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>

          <div class="col-sm-5">
            <label for="min" class="form-label col-sm-10">In Transit</label>
            <input
              v-model="form.product_in_transit"
              type="number"
              class="form-control"
              id="min"
              name="min"
              :style="
                isSubmit
                  ? 'border-color: #ced4da;padding-right: 0.75rem;background: none;'
                  : ''
              "
            />
          </div>
        </div>
      </div>

      <hr class="pt-0 mt-0" style="color: LightGrey" />

      <footer class="m-6">
        <div class="card-toolbar row justify-content-center">
          <div class="col-sm-10">
            <button
              type="submit"
              class="btn btn-sm btn-light btn-primary ms-3 me-2"
              style="font-size: 14px; font-weight: bold"
              @click="submit"
              :disabled="loadingUpdate"
            >
              <div
                v-if="loadingUpdate"
                class="spinner-grow spinner-grow-sm text-light"
                role="status"
              ></div>
              บันทึก
            </button>
            <button
              type="button"
              class="btn btn-sm btn-light"
              style="font-size: 14px; font-weight: bold"
              @click="cancel"
            >
              ยกเลิก
            </button>
          </div>
        </div>
      </footer>
    </form>
  </div>
</template>

<script>
import Swal from "sweetalert2/dist/sweetalert2.js";
import Loader from "../../components/loaderUpdate.vue";
import whApi from "@/api/warehouse/";

export default {
  setup() {
    document.title = "BELUCA | แก้ไขสินค้า";
  },
  components: {
    Loader,
  },
  data: () => ({
    loading: false,
    loadingUpdate: false,
    isSubmit: false,

    form: {
      selectMainProduct: "",
      selectSubProduct: "",

      product_name: "",
      product_desc: "",
      product_barcode: "",
      product_pog: "",
      product_cost_price: "",
      product_wholesale_price: "",
      product_retail_price: "",
      product_promotion_price: "",
      product_min_stock: "",
      product_max_stock: "",
      product_bring_qty: "",
      status: "0",
      approved_by: "",
    },
    ccsSelect: `background-size: 16px 12px;background-position: right 1rem center;background-repeat: no-repeat;background-image: url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%237E8299' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='M2 5l6 6 6-6'/%3e%3c/svg%3e")`,

    mainProduct: [],
    subProduct: [],
  }),

  async created() {
    await this.getMainProduct();
    await this.getSubProduct();
    await this.getOne();
    await this.checkQueryParam();
  },

  methods: {
    checkQueryParam() {
      if (
        this.$route.query.editByRecive &&
        this.$route.query.editByRecive === "true"
      ) {
        this.$router
          .replace({
            query: {
              id: this.$route.query.id,
            },
          })
          .then(() => {
            this.$router.go();
          });
      }
    },
    async getMainProduct() {
      let responseData = [];
      const companyId = localStorage.getItem("companyId");
      const companyBranchId = localStorage.getItem("companyBranchId");

      try {
        responseData = await whApi.mainProduct.getAll({
          companyId: companyId,
          companyBranchId: companyBranchId,
        });
      } catch (error) {
        console.log(error);
      }
      if (responseData.response_status === "SUCCESS") {
        this.mainProduct = responseData.data;
        // this.form.selectMainProduct = responseData.data[0].id;
      }
    },
    async getSubProduct() {
      let responseData = [];
      const companyId = localStorage.getItem("companyId");
      const companyBranchId = localStorage.getItem("companyBranchId");

      try {
        responseData = await whApi.subProduct.getAll({
          companyId: companyId,
          companyBranchId: companyBranchId,
        });
      } catch (error) {
        console.log(error);
      }
      if (responseData.response_status === "SUCCESS") {
        this.subProduct = responseData.data;
        // this.form.selectSubProduct = responseData.data[0].id;
      }
    },
    async getOne() {
      this.loading = true;
      let getOneResponse = {};
      try {
        getOneResponse = await whApi.product.getOne(this.$route.query.id);
      } catch (error) {
        console.log(error);
      }
      if (getOneResponse.response_status === "SUCCESS") {
        this.form = {
          ...getOneResponse.data,
          selectMainProduct: getOneResponse.data.mainProductGroupId,
          selectSubProduct: getOneResponse.data.subProductGroupId,
        };
        this.loading = false;
      }
    },

    async submit() {
      let updateResponse = [];

      await this.validateForm();
      await this.checkFormIsEmpty();
      this.isSubmit = true;

      this.form = {
        ...this.form,
        mainProductGroupId: this.form.selectMainProduct,
        status: this.form.status === "2" ? "0" : this.form.status,
        companyId: parseInt(localStorage.getItem("companyId")),
        companyBranchId: parseInt(localStorage.getItem("companyBranchId")),
        isUpdatePd: true,
      };
      if (this.isValid) {
        this.loadingUpdate = true;
        updateResponse = await whApi.product.update(
          this.$route.query.id,
          this.form
        );
        if (updateResponse.response_status === "SUCCESS") {
          Swal.fire({
            icon: "success",
            title: `แก้ไขสำเร็จ`,
            showConfirmButton: false,
            timer: 1500,
          }).then(() => {
            this.$router.push({
              path: "/warehouse/WH4",
              query: {},
            });
          });
          this.loadingUpdate = false;
        } else {
          Swal.fire({
            icon: "error",
            title: "แก้ไขไม่สำเร็จ !",
            text: updateResponse.message,
            showConfirmButton: false,
            timer: 1500,
          });
          this.loadingUpdate = false;
        }
      }
    },
    checkFormIsEmpty() {
      !this.form.product_name
        ? (this.isValid = false)
        : !this.form.product_cost_price
        ? (this.isValid = false)
        : !this.form.product_wholesale_price
        ? (this.isValid = false)
        : !this.form.product_retail_price
        ? (this.isValid = false)
        : !this.form.selectMainProduct
        ? (this.isValid = false)
        : !this.form.selectSubProduct
        ? (this.isValid = false)
        : !this.form.product_barcode
        ? (this.isValid = false)
        : (this.isValid = true);
    },
    validateForm() {
      let forms = document.querySelectorAll(".needs-validation");
      Array.prototype.slice.call(forms).forEach(function (form) {
        form.addEventListener(
          "submit",
          function (event) {
            event.preventDefault();
            if (!form.checkValidity()) {
              event.stopPropagation();
            }
            form.classList.add("was-validated");
          },
          false
        );
      });
    },
    cancel() {
      this.$router.push({
        path: "/warehouse/WH4",
        query: {},
      });
    },
  },
};
</script>
